// http://radiohlam.ru -    
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "TestPort.h"
#include <STRING.h>
#include <WINDOWS.h>
#include <CONIO.h>
#include <STDIO.h>
#include <math.h>
#include "Unit2.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;
ReadThread *port_reader;
WriteThread *port_writer;
//---------------------------------------------------------------------------
void OpenPort()
{ dcb.DCBlength=sizeof(DCB);
  //  .     nt-  
  // "\\.\PortName",      \    2 
  char PortName[100]="\\\\.\\";

  strcat(PortName,Form1->ComboBox1->Text.c_str());
  Port=CreateFile(PortName,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_FLAG_OVERLAPPED,NULL);
  if(Port==INVALID_HANDLE_VALUE)
  { MessageBox(NULL,"  ","Error",MB_OK);
    return;
  }
  else
  { if(GetCommState(Port,&dcb)==0)
    { MessageBox(NULL,"   ","Error",MB_OK);
      CloseHandle(Port);
      Port=INVALID_HANDLE_VALUE;
      return;
    }
    else
    {
      dcb.BaudRate=StrToInt(Form1->ComboBox2->Text);
      dcb.ByteSize=StrToInt(Form1->ComboBox3->Text);
      switch(Form1->ComboBox4->ItemIndex)
           { case 0 : dcb.Parity=0;     // None
                      break;
             case 1 : dcb.Parity=1;     // Odd
                      break;
             case 2 : dcb.Parity=2;     // Even
                      break;
             case 3 : dcb.Parity=3;     // Mark
                      break;
             case 4 : dcb.Parity=4;     // Space
                      break;
             default: dcb.Parity=0;     // None
           }
      switch(Form1->ComboBox5->ItemIndex)
          {case 0 : dcb.StopBits=0;     // 1
                    break;
           case 1 : dcb.StopBits=1;     // 1,5
                    break;
           case 2 : dcb.StopBits=2;     // 2
                    break;
           default: dcb.StopBits=2;     // 2
          }
      dcb.fBinary=true;          //  
      dcb.fOutxCtsFlow=false;    //  CTS
      dcb.fOutxDsrFlow=false;    //  DSR
      dcb.fDtrControl=DTR_CONTROL_DISABLE;     // DTR
      dcb.fDsrSensitivity=false;               //  DSR
      dcb.fNull=false;           //  
      dcb.fRtsControl=RTS_CONTROL_DISABLE;    // RTS
      dcb.fAbortOnError=false;   //  /  

   }
   if(SetCommState(Port,&dcb)==0)
   { MessageBox(NULL,"   ","Error",MB_OK);
     CloseHandle(Port);
     Port=INVALID_HANDLE_VALUE;
     return;
   }
   memset(wr_buf,0,BUFSIZE);        //    
   wr_buf_len=0;                    //  
   SetupComm(Port,BUFSIZE+100,BUFSIZE+100);       //    
   PurgeComm(Port,PURGE_RXCLEAR|PURGE_TXCLEAR);   //     
   Form1->Button1->Enabled=false;
   Form1->Button2->Enabled=true;

   wr_counter=0;
   rd_counter=0;
   if(Form1->CheckBox1->Checked==true)
         WR_COUNTER_FLAG=true;
    else WR_COUNTER_FLAG=false;
   if(Form1->CheckBox2->Checked==true)
         RD_COUNTER_FLAG=true;
    else RD_COUNTER_FLAG=false;

   port_reader=new ReadThread(false);  //    
   port_reader->FreeOnTerminate=false; // -,      

   port_writer=new WriteThread(true);  //      
   port_writer->FreeOnTerminate=false; //   
  }
}
//---------------------------------------------------------------------------
void ClosePort()
{   if(port_writer)
  { port_writer->Terminate(); //    -  
    SetEvent(ovr_wr.hEvent);  //    WaitForSingleObject
    port_writer->Resume();    // ,    
    port_writer->WaitFor();
//    port_writer->FreeOnTerminate=true; //  
  }

  if(port_reader)
  { port_reader->Terminate(); //    -  
    SetEvent(ovr_rd.hEvent);  //    WaitForSingleObject
    port_reader->Resume();    // ,    
    port_reader->WaitFor();
//    port_reader->FreeOnTerminate=true; //  
  }

  CloseHandle(Port);
  Port=INVALID_HANDLE_VALUE;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
__fastcall ReadThread::ReadThread(bool CreateSuspended) // 
     : TThread(CreateSuspended)
{
}
//---------------------------------------------------------------------------
void __fastcall ReadThread::Execute()
{COMSTAT    port_status;
 DWORD      temp, mask;

 ovr_rd.hEvent=CreateEvent(NULL, true, true, NULL); // 
 SetCommMask(Port, EV_RXCHAR);                      //     
 while(!Terminated)                      //     -  
  { WaitCommEvent(Port,&mask,&ovr_rd);   //   
    WaitForSingleObject(ovr_rd.hEvent,INFINITE);   //       
    if(GetOverlappedResult(Port,&ovr_rd,&temp,true)) //     WaitCommEvent
     if((mask&EV_RXCHAR)!=0)            //     
      { ClearCommError(Port,&temp,&port_status);    //  port_status
        rd_buf_len=0;
        rd_buf_len=port_status.cbInQue;  //-  
        if(rd_buf_len)
         { ReadFile(Port,rd_buf,rd_buf_len,&temp,&ovr_rd); //  - 
           Synchronize(PlaceReadedOnForm);
         }
      }
  }
 CloseHandle(ovr_rd.hEvent); // -
 ReturnValue=0;              //     
}
//---------------------------------------------------------------------------
void __fastcall ReadThread::PlaceReadedOnForm()
{ int buflen, i,j;
  char buf[BUFSIZE], hexbuf[3*BUFSIZE];
  AnsiString tempch;

  memset(buf,0,BUFSIZE);
  buflen=rd_buf_len;
  memcpy(buf,rd_buf,buflen);      //     
  memset(rd_buf,0,BUFSIZE);       //  
  memset(rd_log,0,3*BUFSIZE+10);

  if(Form1->RadioButton3->Checked==true) //   ASCII
   { strcat(rd_log,"ASCII<--:");
     for(i=0;i<buflen;i++)               //    1Fh
     { if(buf[i]<31)
        { rd_log[i+9]=31;  //31=1Fh
          buf[i]=31;
        }
       else rd_log[i+9]=buf[i];
     }
     Form1->Memo2->Lines->Add(buf);    //    Memo2
     Form1->Memo3->Lines->Add(rd_log);
   }
   else                             //   hex
   { memset(hexbuf,0,3*BUFSIZE);    //   hex
     strcat(rd_log,"HEX<----:");
     for(i=0;i<buflen;i++)
      { tempch=IntToHex(buf[i],2);
        j=tempch.Length();
        tempch.Delete(1,j-2); //      FFFF FFXX

        strcat(rd_log,tempch.c_str());
        strcat(rd_log," ");
        strcat(hexbuf,tempch.c_str());
        strcat(hexbuf," ");
      }
     Form1->Memo2->Lines->Add(hexbuf);    //    Memo2
     Form1->Memo3->Lines->Add(rd_log);
   }

   if(RD_COUNTER_FLAG==true)               //  -    
    { rd_counter+=buflen;
      Form1->Edit8->Text=IntToStr(rd_counter);
    }
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
__fastcall WriteThread::WriteThread(bool CreateSuspended) // 
     : TThread(CreateSuspended)
{
}
//---------------------------------------------------------------------------
void __fastcall WriteThread::Execute()
{ DWORD      temp;

  ovr_wr.hEvent=CreateEvent(NULL,true,true,NULL);      // 
  while(!Terminated)
  { if(wr_buf_len!=0)                                  //  ,   - 
    { WriteFile(Port,wr_buf,wr_buf_len,&temp,&ovr_wr); //   
      WaitForSingleObject(ovr_wr.hEvent,INFINITE);     //    ,       
      if(GetOverlappedResult(Port,&ovr_wr,&temp,true))
           WR_FLAG=true;
      else WR_FLAG=false;         //    -  ,   - 

      Synchronize(ShowResultMessage);
      port_writer->Suspend();    //  
    }
  }
  CloseHandle(ovr_wr.hEvent); //    -  
  ReturnValue=0;              //     
}
//---------------------------------------------------------------------------
void __fastcall WriteThread::ShowResultMessage()
{ if(!WR_FLAG) MessageBox(NULL,"  ","Error",MB_OK);
   else
   { if(WR_COUNTER_FLAG==true)               //  -    
     { wr_counter+=wr_buf_len;
       Form1->Edit7->Text=IntToStr(wr_counter);
     }
       memset(wr_log,0,BUFSIZE+10);
       if(Form1->RadioButton1->Checked==true)
        { strcat(wr_log,"ASCII-->:");
          strcat(wr_log,wr_buf);
        }
       else
        { strcat(wr_log,"HEX---->:");
          strcat(wr_log,(ansi_wr_buf_hex).c_str());
        }
       Form1->Memo3->Lines->Add(wr_log);
   }
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner) // 
	: TForm(Owner)
{ Port=INVALID_HANDLE_VALUE;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{
 ClosePort();
 Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
 if(Port!=INVALID_HANDLE_VALUE)
 { Button1->Enabled=true;
   Button2->Enabled=false;
   ClosePort();
 }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
 OpenPort();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
Memo1->Clear();
Memo4->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{
Memo2->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
 if(CheckBox1->Checked==false)
        WR_COUNTER_FLAG=false;
  else  WR_COUNTER_FLAG=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox2Click(TObject *Sender)
{
 if(CheckBox2->Checked==false)
        RD_COUNTER_FLAG=false;
  else  RD_COUNTER_FLAG=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button5Click(TObject *Sender)
{
 wr_counter=0;
 Edit7->Text="0";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button6Click(TObject *Sender)
{
 rd_counter=0;
 Edit8->Text="0";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button7Click(TObject *Sender)
{
 Memo3->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button8Click(TObject *Sender)
{
 Memo3->Lines->SaveToFile("RH_Com.log");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button9Click(TObject *Sender)
{
 Memo3->Lines->LoadFromFile("RH_Com.log");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RadioButton1Enter(TObject *Sender)
{
 Memo1->Visible=true;
 Memo4->Visible=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RadioButton2Enter(TObject *Sender)
{
Memo1->Visible=false;
Memo4->Visible=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Memo4KeyPress(TObject *Sender, char &Key)
{char *CompetentChars="0123456789abcdefABCDEF";
 AnsiString tempstr,tempstr2,tempstr3;
 char substr;
 int templen,TextPos,i,n;
 double tempc, temps, temps2, temp2;
 TPoint CarretPosM4;

 CarretPosM4.y = SendMessage(Memo4->Handle, EM_LINEFROMCHAR, Memo4->SelStart,0);
 CarretPosM4.x = Memo4->SelStart - SendMessage(Memo4->Handle, EM_LINEINDEX, CarretPosM4.y, 0);
 TextPos=Memo4->SelStart;                  //    
 tempstr=Memo4->Lines->Strings[CarretPosM4.y];   //    
 templen=tempstr.Length();

 //---------
 if(strchr(CompetentChars,Key)!=0)//    , 
  { //--1)
   AnotherChance:
    tempc=modf(CarretPosM4.x/3.0,&temp2);   //   ..  3
    if(tempc==0)   //     0,     |xx_|xx...
     {
      if(templen!=0)      //     ,   
       {
        temps=modf((templen+1)/3.0,&temp2);   //   +1  3
        if(temps==0)            //   0,    ...xx_xx
         {
          tempstr=tempstr+" ";                      //   " "
          for(i=CarretPosM4.x;i<templen;i=i+3)
           { substr=tempstr[i+2];
             tempstr[i+2]=tempstr[i+3];
             tempstr[i+3]=substr;
           }
         }
         else // ,    ...xx_x
         {
          for(i=CarretPosM4.x;i<templen-1;i=i+3)
           { substr=tempstr[i+2];
             tempstr[i+2]=tempstr[i+3];
             tempstr[i+3]=substr;
           }
         }
       }
     }
//--2)
    tempc=modf((CarretPosM4.x+2)/3.0,&temp2);//   ..+2  3
    if(tempc==0)   //     0,     x|x_x|x...
     {
      if(templen!=0)      //     ,   
       {
        temps=modf((templen+1)/3.0,&temp2);   //   +1  3
        if(temps==0)            //   0,    ...xx_xx
         {
          tempstr=tempstr+" ";                      //   " "
          for(i=CarretPosM4.x;i<templen;i=i+3)
           { substr=tempstr[i+1];
             tempstr[i+1]=tempstr[i+2];
             tempstr[i+2]=substr;
           }
         }
         else // ,    ...xx_x
         {
          for(i=CarretPosM4.x;i<templen-1;i=i+3)
           { substr=tempstr[i+1];
             tempstr[i+1]=tempstr[i+2];
             tempstr[i+2]=substr;
           }
         }
       }
     }
//--3)
    tempc=modf((CarretPosM4.x+1)/3.0,&temp2);//   ..+1  3
    if(tempc==0)   //     0,     xx|_xx|...
     {
      if(CarretPosM4.x==templen) //      
       { tempstr=tempstr+" ";    //  
         TextPos=TextPos+1;
       }
       else
       { TextPos=TextPos+1;
         CarretPosM4.x=CarretPosM4.x+1;
         goto AnotherChance;
       }
     }
   Memo4->Lines->Strings[CarretPosM4.y]=tempstr.UpperCase();
   Memo4->SelStart=TextPos;       //    
  }

//-----backspace---
 else if(Key==8)     //  backspace
 { //--1)
    tempc=modf(CarretPosM4.x/3.0,&temp2);   //   ..  3
    if(tempc==0)   //     0,     |xx_|xx...
     {
      if(CarretPosM4.x!=0) //     ,   
       { TextPos=TextPos-1;             //  
         CarretPosM4.x=CarretPosM4.x-1; //   3)
         goto AnotherChance2;
       }
      else //,           
       {
        if((templen!=0)&&(CarretPosM4.y>0))
        {
         n=Memo4->Lines->Strings[CarretPosM4.y-1].Length(); //   
         if(n!=0)
          { //    xx_xx  xx_x
            temps=modf((n+1)/3.0,&temp2);
            if(temps==0) tempstr=" "+tempstr; // " "  
            else   //   xx_x, 
             { temps2=modf((templen+1)/3.0,&temp2);
               if(temps2==0)  //   xx_xx
                { tempstr=tempstr+" "; // " "  
                  for(i=2;i<templen+1;i=i+3)
                   { substr=tempstr[i];
                     tempstr[i]=tempstr[i+1];
                     tempstr[i+1]=substr;
                   }
                }
               else          //   xx_x
                { for(i=2;i<templen;i=i+3)
                   { substr=tempstr[i];
                     tempstr[i]=tempstr[i+1];
                     tempstr[i+1]=substr;
                   }
                }
             }
          }
        }
       }
     }
//--2)
    tempc=modf((CarretPosM4.x+2)/3.0,&temp2);//   ..+2  3
    if(tempc==0)   //     0,     x|x_x|x...
     {
       temps=modf((templen+1)/3.0,&temp2);   //   +1  3
       if(temps==0)            //   0,    ...xx_xx
        {
         for(i=CarretPosM4.x;i<templen-1;i=i+3)
          { substr=tempstr[i+2];
            tempstr[i+2]=tempstr[i+3];
            tempstr[i+3]=substr;
          }
        }
        else // ,    ...xx_x
         { if(CarretPosM4.x!=templen)     //    
            { for(i=CarretPosM4.x;i<templen;i=i+3)
               { substr=tempstr[i+2];
                 tempstr[i+2]=tempstr[i+3];
                 tempstr[i+3]=substr;
               }
               tempstr.Delete(templen,1); //   ()
            }
           else if(templen>1) //        1 
            { tempstr.Delete(templen-1,1); //   ()
              TextPos=TextPos-1;
            }
         }
     }
//--3)
AnotherChance2:
    tempc=modf((CarretPosM4.x+1)/3.0,&temp2);//   ..+1  3
    if(tempc==0)   //     0,     xx|_xx|...
     {
      temps=modf((templen+1)/3.0,&temp2);   //   +1  3
      if(temps==0)             //   0,    ...xx_xx
       { if(CarretPosM4.x!=templen) //       
          {
           for(i=CarretPosM4.x;i<templen;i=i+3)
            { substr=tempstr[i+1];
              tempstr[i+1]=tempstr[i+2];
              tempstr[i+2]=substr;
            }
          }
       }
      else // ,    ...xx_x
       {
        for(i=CarretPosM4.x;i<templen;i=i+3)
         { substr=tempstr[i+1];
           tempstr[i+1]=tempstr[i+2];
           tempstr[i+2]=substr;
         }
        tempstr.Delete(templen,1); //   ()
       }
     }
   Memo4->Lines->Strings[CarretPosM4.y]=tempstr.UpperCase();
   Memo4->SelStart=TextPos;       //    
 }

//-----enter---
//           MessageBox(NULL,tempstr.c_str(),"Error",MB_OK);
 else if(Key==13&&ENTER_FLAG==false)   //  enter  
  { //    (  -   +1  3  0   =0)
    tempc=modf((templen+1)/3.0,&temp2);        //   +1  3
    if(tempc==0)                               //    
     { //--- --
       tempc=modf(CarretPosM4.x/3.0,&temp2);   //   ..  3
       if(tempc==0)   //     0,     |xx_|xx...
        { if(CarretPosM4.x!=0)
          { tempstr.Delete(CarretPosM4.x,1); //   
            TextPos=TextPos-1;
          }
        }
       tempc=modf((CarretPosM4.x+1)/3.0,&temp2);//   ..+1  3
       if(tempc==0)   //     0,     xx|_xx|...
        { tempstr.Delete(CarretPosM4.x+1,1); //   
        }
       tempc=modf((CarretPosM4.x+2)/3.0,&temp2);//   ..  3
       if(tempc==0)   //     0,     x|x_x|x...
        { Key=0;
          MessageBox(NULL,"       .","Error",MB_OK);
        }
       Memo4->Lines->Strings[CarretPosM4.y]=tempstr.UpperCase();
       Memo4->SelStart=TextPos;       //    
     }
    else if(templen!=0)    //          
     { Key=0;
       MessageBox(NULL,"    .","Error",MB_OK);
     }
  }
 else
 { Key=0;
   ENTER_FLAG=false;
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::About1Click(TObject *Sender)
{
Form2->Enabled=true;
Form2->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Memo4KeyDown(TObject *Sender, WORD &Key,
	TShiftState Shift)
{ AnsiString tempstr,tempstr2,tempstr3;
  char *hex_buf, bin_buf[2];
  int templen,i,n;
  double tempc, temp2;
  TPoint CarretPosM4;

 if(Key==VK_DELETE)Key=0;
 else if(Key==13&&Shift.Contains(ssShift))
 { ENTER_FLAG=true;

   CarretPosM4.y = SendMessage(Memo4->Handle, EM_LINEFROMCHAR, Memo4->SelStart,0);
   tempstr=Memo4->Lines->Strings[CarretPosM4.y];   //    
   templen=tempstr.Length();

   //    (  -   +1  3  0   =0)
   tempc=modf((templen+1)/3.0,&temp2);        //   +1  3
   if(tempc==0)                               //    
    { if(Port!=INVALID_HANDLE_VALUE)
       { if(templen>(3*BUFSIZE-1))
          MessageBox(NULL,("  (>"+IntToStr(BUFSIZE)+")").c_str(),"Error",MB_OK);
         else
          { ansi_wr_buf_hex=tempstr;
            tempstr2=StringReplace(tempstr," ","",TReplaceFlags()<<rfReplaceAll);//  
            tempstr2=tempstr2.LowerCase(); //   
            memset(wr_buf,0,BUFSIZE); //   
            memset(bin_buf,0,2);      //  - (    )
            n=tempstr2.Length();
            wr_buf_len=0;
            for(i=1;i<n;i=i+2)
             { tempstr3=tempstr2.SubString(i,2);
               if(tempstr3=="00") memset(wr_buf+wr_buf_len,0,1);
               else
               {
                 hex_buf=tempstr3.c_str();
                 HexToBin(hex_buf,bin_buf,1);
                 memset(wr_buf+wr_buf_len,bin_buf[0],1);
               }
               wr_buf_len=wr_buf_len+1;
             }
//        MessageBox(NULL,wr_buf,"Error",MB_OK);
            PurgeComm(Port,PURGE_TXCLEAR);       //   
            port_writer->Resume();               //  
          }
       }
      else MessageBox(NULL,"  ,    !","Error",MB_OK);
    }
   else MessageBox(NULL,"    ","Error",MB_OK);
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Memo1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{char *si_wr_buf;
 AnsiString tempstr;
 TPoint CarretPos;

  if(Key==13&&Shift.Contains(ssShift))
  {ENTER_FLAG=true;
   if(Port!=INVALID_HANDLE_VALUE)
    {
      CarretPos.y = SendMessage(Memo1->Handle, EM_LINEFROMCHAR, Memo1->SelStart,0);
      tempstr=Memo1->Lines->Strings[CarretPos.y]; //  
      si_wr_buf=tempstr.c_str();                 //   
      wr_buf_len=strlen(si_wr_buf);
      if(wr_buf_len>BUFSIZE)
        MessageBox(NULL,("  (>"+IntToStr(BUFSIZE)+")").c_str(),"Error",MB_OK);
      else
       {
        memset(wr_buf,0,BUFSIZE);            //   
        memcpy(wr_buf,si_wr_buf,wr_buf_len); //      

        PurgeComm(Port,PURGE_TXCLEAR);       //   
        port_writer->Resume();               //  
       }
    }
    else MessageBox(NULL,"  ,    !","Error",MB_OK);
    Key=0;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Memo1KeyPress(TObject *Sender, char &Key)
{
 if(ENTER_FLAG==true)
 {
  Key=0;
  ENTER_FLAG=false;
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox1Change(TObject *Sender)
{
 if(Port!=INVALID_HANDLE_VALUE)
 { Button1->Enabled=true;
   Button2->Enabled=false;
   ClosePort();
 }
}
//---------------------------------------------------------------------------

