// http://radiohlam.ru -    
//---------------------------------------------------------------------------
#ifndef TestPortH
#define TestPortH
#define BUFSIZE 1024
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Menus.hpp>
#include <mem.h>
#include <vcl\Dialogs.hpp>
//---------------------------------------------------------------------------
  DCB    dcb;                  // DCB
  HANDLE Port;                 // 
  char wr_buf[BUFSIZE], rd_buf[BUFSIZE], wr_log[BUFSIZE+10], rd_log[3*BUFSIZE+10];    //    +    
  AnsiString ansi_wr_buf_hex;
  bool WR_FLAG, RD_COUNTER_FLAG, WR_COUNTER_FLAG, ENTER_FLAG;
  OVERLAPPED ovr_wr, ovr_rd;
  int rd_counter, wr_counter, wr_buf_len, rd_buf_len;

void OpenPort(void);
void ClosePort(void);
//---------------------------------------------------------------------------
class ReadThread : public TThread
{
private:
protected: void __fastcall Execute();            //  
           void __fastcall PlaceReadedOnForm();  //    
public: __fastcall ReadThread(bool CreateSuspended);
};
//---------------------------------------------------------------------------
class WriteThread : public TThread
{
private:
protected: void __fastcall Execute();            //  
           void __fastcall ShowResultMessage();  //    
public: __fastcall WriteThread(bool CreateSuspended);
};
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
	TPanel *Panel1;
	TGroupBox *GroupBox1;
	TMainMenu *MainMenu1;
	TMenuItem *File1;
	TMenuItem *Exit1;
	TMenuItem *Help1;
	TMenuItem *About1;
	TGroupBox *GroupBox2;
	TLabel *Label1;
	TLabel *Label2;
	TLabel *Label3;
	TLabel *Label4;
	TLabel *Label5;
	TEdit *Edit6;
	TButton *Button1;
	TButton *Button2;
	TGroupBox *GroupBox3;
	TMemo *Memo1;
	TGroupBox *GroupBox4;
	TMemo *Memo2;
	TRadioButton *RadioButton3;
	TRadioButton *RadioButton4;
	TRadioButton *RadioButton1;
	TRadioButton *RadioButton2;
	TButton *Button3;
	TButton *Button4;
	TEdit *Edit7;
	TEdit *Edit8;
	TButton *Button5;
	TButton *Button6;
	TCheckBox *CheckBox1;
	TCheckBox *CheckBox2;
	TGroupBox *GroupBox5;
	TMemo *Memo3;
	TButton *Button7;
	TButton *Button8;
	TButton *Button9;
	TMemo *Memo4;
        TLabel *Label6;
        TLabel *Label7;
        TLabel *Label8;
        TComboBox *ComboBox1;
        TComboBox *ComboBox2;
        TComboBox *ComboBox3;
        TComboBox *ComboBox4;
        TComboBox *ComboBox5;
	void __fastcall Exit1Click(TObject *Sender);
	void __fastcall Button2Click(TObject *Sender);
	void __fastcall Button1Click(TObject *Sender);
	void __fastcall Button3Click(TObject *Sender);
	void __fastcall Button4Click(TObject *Sender);
	void __fastcall CheckBox1Click(TObject *Sender);
	void __fastcall CheckBox2Click(TObject *Sender);
	void __fastcall Button5Click(TObject *Sender);
	void __fastcall Button6Click(TObject *Sender);
	void __fastcall Button7Click(TObject *Sender);
	void __fastcall Button8Click(TObject *Sender);
	void __fastcall Button9Click(TObject *Sender);
	void __fastcall RadioButton1Enter(TObject *Sender);
	void __fastcall RadioButton2Enter(TObject *Sender);
	void __fastcall Memo4KeyPress(TObject *Sender, char &Key);
	void __fastcall About1Click(TObject *Sender);
	void __fastcall Memo4KeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
        void __fastcall Memo1KeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
        void __fastcall Memo1KeyPress(TObject *Sender, char &Key);
        void __fastcall ComboBox1Change(TObject *Sender);
private:	// User declarations
public:		// User declarations
	__fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern WriteThread *port_writer;
extern ReadThread *port_reader;
extern TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
